﻿using System;
using System.ComponentModel;

namespace SingletonApp
{
    class DataContext : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        private static DataContext _singleton;
        private static string _user;
        public int MaValeur { get; set; }

        public static DataContext Singleton
        {
            get
            {
                if (_singleton == null)
                {
                    _singleton = new DataContext();
                }

                return _singleton;
            }
        }

        public String User
        {
            get
            {
                return _user;
            }
            set
            {
                _user = value;
                OnPropertyChanged("User");
            }
        }

        // Create the OnPropertyChanged method to raise the event 
        protected void OnPropertyChanged(string name)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(name));
            }

        }

    }
}
